#! /usr/bin/env python
# _*-coding:utf-8-*-
# Modifié par PPPP, GPLv3+
# Script qui gère le tracking depuis une source vidéo donnée
# AntsTracking v0.4.5

# ========== Importations
import cv
import datetime, sys#, sqlite3
import mod_multiplexage, mod_tracking, mod_fps, mod_affichage, mod_traitement, mod_analyse#, mod_acquisition

# ========== Initialisation
dico_images = {}				# Dictionnaire contenant les différentes images après traitement
time = mod_fps.init()				# Compteur temporel et FPS
tracking_data = mod_tracking.tracking_init()	# Initialisation du dictionnaire de tracking et de contrôle
tracking_data2 = mod_tracking.tracking_init()	# Initialisation du dictionnaire de tracking et de contrôle
tracking_data['seuil2'] = 17			# id.

# =========== Gestion des entrées utilisateur
if len(sys.argv) == 1 :
	print "Nom du dossier d'entrée"
	nom_fichier = raw_input()
	print nom_fichier

	print "Nom du fichier de sortie"
	print "Laisser vide pour ne rien enregistrer"
	#nom_sortie = nom_fichier + '--'
	nom_sortie = raw_input()
	if nom_sortie == '' :
		print "Rien ne sera enregistré"
		nom_sortie = None
	else :
		nom_sortie = nom_fichier + '--' + nom_sortie
		print nom_sortie
	# =========== Message de bienvenue
	print  "Hot keys: \n" \
		"\tESC - quit the program\n" \
		"\ts - show/hide points\n" \
		"\tr - auto-initialize tracking\n" \
		"\tc - delete all the points\n" \
		"\tn - switch the \"night\" mode on/off\n" \
		"\tSPACE - play/pause\n" \
		"\tm - Play video faster\n" \
		"\tl - Play video slower\n" \
		"\te - save the frame\n" \
		"\tb - next reference frame\n" \
		"\ti - switch view\n" \
		"To add/remove a feature point click it\n"
		
elif '-h' in sys.argv :
	print "Usage en ligne de commande :\n" \
	"\t -i Fichier d'entrée\n" \
	"\t -o Fichier de sortie\n" \
	"\t -s Seuil à appliquer\n" \
	"\t -f numero de la derniere image\n"
	#"\t -ref Liste des images de référence e.g: 1,234,657,12344\n"
	sys.exit(0)
else :
	nom_fichier = sys.argv[2]
	nom_sortie = nom_fichier + '--' + sys.argv[4]
	tracking_data['seuil2'] = int(sys.argv[6])
	i_fin = int(sys.argv[8])
	# Liste des images de référence pas implémentée
	print "Nom fichier entrée : " + nom_fichier
	print "Nom fichier sortie : " + nom_sortie
	print "Seuil : " + str(tracking_data['seuil2'])
	print "Image de fin : " + str(i_fin)

# ========== Initialisation (suite)


tracking_data['seuil1'] = 21			# Initialisations relatives à la détection de clics, à l'inteface avec l'utilisateur
tracking_data['seuil3'] = 255			# id.
tracking_data['erosion'] = 0			# id.



tracking_data['save'] = 0
tracking_data['next'] = 0
"""tracking_data = {'seuil1' : 21,
	'seuil2' : 17, 
	'seuil3' : 255,
	'erosion' : 0,
	'save' : 0,
	'next' : 0}				# Dictionnaire d'interactions avec l'utilisateur"""
dico_player = mod_multiplexage.player_init()	# Initialisation du dictionnaire de contrôle du player
pointeurgestiontrack = mod_affichage.init(tracking_data)	# /!\ A initialiser à la fin, initialisation de la gestion de l'affichage (nécessite le précédent)
retour = [0, 1, 0]				# Compteur pour l'arrêt du programme, pour l'affichage des points
dico_ref = mod_traitement.reference_init()	# Chargement de l'image de référence
dico_sortie = []

# ===== Initialisation DB
if nom_sortie :
        fichier = open("./exportation/"+nom_sortie+".txt", "w")
	#baseDonn = sqlite3.connect("./Tracking2/" + nom_sortie + '.db')		# Ouverture de la base de données
	#cur = baseDonn.cursor()
	#cur.execute("CREATE TABLE infos (nom varchar, date varchar)")
	#info = 'INSERT INTO infos (nom, date) VALUES ("%s", "%s")' % (nom_fichier, str(datetime.date.today()))
	#cur.execute(info)
	#cur.execute("CREATE TABLE traces (image int, x float, y float)")
	#baseDonn.commit()



if __name__ == '__main__':
    # ========= display
    print "Vous utilisez AntsTracking v0.4.6"

    # ========== La boucle principale du programme
    n=0	# Suivant le type de video (0 ou 1)
    k=1	# Nécessaire pour les vitesses au ralenti
    while 1:		# Do forever
    	
    	# ==== Initialisations
    	if tracking_data['add_remove_pt'] :
    		tracking_data['add_remove_pt'] = False
    		print tracking_data['pt']
    	time = mod_fps.fps(time)			# Lancement du compteur temporel pour 10 FPS
    	dico_images['brut'] = mod_multiplexage.multiplexage(n, nom_fichier, dico_player)# Récupération de l'image
    	
    	# ==== Gestion de l'image de référence
    	dico_ref = mod_traitement.next_reference(dico_ref, tracking_data)	# Change l'image de référence si nécessaire
    	dico_ref = mod_traitement.new_reference(dico_ref, tracking_data, dico_images['brut'])# Enregistre l'image de référence si nécessaire
    	# ==== Gestion de la différence absolue 
        if cv.GetSize(dico_ref['reference']) != cv.GetSize(dico_images['brut']):
                print "Warning, reference image has shape " + str(cv.GetSize(dico_ref['reference'])) + " while the current image has shape " + cv.GetSize(dico_images['brut']) + ". Crashing. You should also check the shape of the 'erreur.jpg' file in Videos."
    	dico_images['diff'] = mod_traitement.difference(dico_ref['reference'], dico_images['brut'])
    	
	# ==== Traitement des images
	(grey, dico_images['diff']) = mod_traitement.contraste(dico_images['diff'], tracking_data['seuil2'], tracking_data['erosion'])	# Méthode de recalage de la moyenne et de laplacien	
	# ==== Tracking
	dico_images['grey2'] = cv.CreateImage(cv.GetSize(dico_images['brut']), cv.IPL_DEPTH_8U, 3)
	cv.CvtColor(grey, dico_images['grey2'], cv.CV_GRAY2BGR)			# Transformation de couleur
	tracking_data2['need_to_init'] = 1					# initialisation cyclique
    	mod_tracking.tracking(dico_images['grey2'], tracking_data2)		# Tracking, on récupère les points potentiels
    	#mod_tracking.tracking(dico_images['grey2'], tracking_data)		# Tracking
	#tracking_data['pts'] = mod_analyse.nouveaux_pts(tracking_data2['features'], tracking_data['features'])	# Calcul des nouveaux points
	
	# ==== Génération du dictionnaire de sortie
	if nom_sortie :
                
		for i in tracking_data2['features'] :
                        fichier.write("%s %s %s\n" % (str(n), str(i[0]), str(i[1])))
		#	cur.execute("INSERT INTO traces (image, x, y) VALUES (%s, %s, %s)" %(str(n), str(i[0]), str(i[1])))
		#if n%1000 == 0 :
		#	baseDonn.commit()		
    	# ==== Affichage
    	mod_affichage.affichage(retour, time, tracking_data, tracking_data2, dico_images, pointeurgestiontrack, dico_player, n)	# On envoie à la fonction tout le nécessaire
    	#			# end, fps    points de track, images,  IHM, dico lecture, numero frame
    	try :
    		if i_fin <= n :
    			print "Auto interruption - image :" + str(n)
    			retour[0] =1
    	except :
    		pass
	if retour[0] :		# Sortie de boucle
		if nom_sortie :
			#baseDonn.commit()
                        fichier.close()
			print "Fichier enregistré !"
		else :
			print "Rien n'a été enregistré"
		sys.exit(0)
		
    	dico_player = mod_multiplexage.convert_dico(dico_player)	# Génération de l'index de la frame suivante
    	if dico_player["jouer"] != 0 :					# Si on n'est pas en pause
	    	if abs(dico_player["vitesse_vraie"]) < 1 :		# Gestion du ralenti
	    	    	if k==1 :
	    			k= 1./abs(dico_player["vitesse_vraie"])
	    			n+=int(dico_player["vitesse_vraie"]/abs(dico_player["vitesse_vraie"]))
	    		k-=1
	    		n=n

	    	else :					# Gestion de la lecture normale et accélérée
	    		k=1
			n += dico_player["vitesse_vraie"]
		if n<0 :				# Condition d'arrêt au debut de la vidéo : éviter les index négatifs
			n=0
