#! /usr/bin/env python
# _*-coding:utf-8-*-
# Modifié par PPPP, GPLv3+
# Script qui gère l'affichage des sources video avec des filtres eventuels
# AntsTracking v0.2.2/mod_affichage v0.2.2

# Pas d'affichage, choix du fond, choix des filtres, affichage des fps, choix des curseurs

# ========= Importation
import cv

# ========= Fonctions
def init(data) :
	# first, create the necessary windows
	cv.NamedWindow ('AntsTracking', cv.CV_WINDOW_AUTOSIZE)
	# register the mouse callback
	cv.SetMouseCallback ('AntsTracking', on_mouse, data)
	# ==== Gestion des trackbar
	gestion_track = GestionTrackbar()	# Définition de la classe 'mémoire'
	gestion_track.var = {}
	gestion_track.var['seuil1'] = data['seuil1']	# Initialisation des variables
        gestion_track.var['seuil2'] = data['seuil2']
        gestion_track.var['seuil3'] = data['seuil3']
        gestion_track.var['erosion'] = data['erosion']
        cv.CreateTrackbar("Seuil Adapatif", "AntsTracking", 21, 255, gestion_track.seuil1)	# Création des trackbar
        cv.CreateTrackbar("Seuil 1", "AntsTracking", data['seuil2'], 255, gestion_track.seuil2)
        cv.CreateTrackbar("Seuil 2", "AntsTracking", 255, 255, gestion_track.seuil3)
        cv.CreateTrackbar("Erosion", "AntsTracking", 0, 10, gestion_track.erosion)
        return gestion_track
          
def affichage(retour, fps, tracking_data, tracking_data2, dico_images, gestion_track, dico_player, n) :
	frame = dico_images['brut']	# Swapping
	diff = dico_images['diff']	# id.
	grey2 = dico_images['grey2']	# id.

        # ==== Gestion de la sortie
        c = cv.WaitKey (10)
        if c == 27:  # user has press the ESC key, so exit
		retour[0] = 1
	          		
        # ==== Gestion du tracking
        if 32 <= c and c < 128:
          cc = chr(c).lower()
          if cc == 'r':
              tracking_data['need_to_init'] = True
          elif cc == 'c':
              tracking_data['features'] = []
          elif cc == 'n':
              tracking_data['night_mode'] = not tracking_data['night_mode']
          elif cc == 's' :	# Affichage des points
          	if retour[1] :
            		retour[1] = 0
            	else : 
            		retour[1] = 1
          elif cc == "i" :
          	retour[2] +=1
          	retour[2] = retour[2]%3
          elif cc == "e" : 	# Enregistrer l'image
          	tracking_data['save'] = 1
          elif cc == "b" :
          	tracking_data['next'] = 1
          elif cc == " " :	# Play/pause
          	dico_player["jouer"] += 1
          	dico_player["jouer"] = dico_player["jouer"]%2
          elif cc == "m" :	# Jouer en accéléré
          	dico_player["vitesse"] += 1
          	dico_player["vitesse"] = dico_player["vitesse"]%24
          elif cc == "l" :	# Jouer en ralenti
          	dico_player["vitesse"] -= 1
          	dico_player["vitesse"] = dico_player["vitesse"]%24
        # ==== Gestion des trackbar (mise à jour)
	tracking_data['erosion'] = gestion_track.var['erosion']
	tracking_data['seuil1'] = gestion_track.var['seuil1']
	tracking_data['seuil2'] = gestion_track.var['seuil2']
	tracking_data['seuil3'] = gestion_track.var['seuil3']
        # ==== Affichage de l'image et gestion des points
        font = cv.InitFont(cv.CV_FONT_HERSHEY_PLAIN, 1, 1) 	# Initialisation de la police
        if retour[2] == 1:					# Affichage de l'image brute
       		if tracking_data['night_mode']:
            	# night mode: only display the points
           		 cv.SetZero(frame)
		if retour[1] :
        		#for the_point in tracking_data['features']:
        		#	cv.Circle(frame, (int(the_point[0]), int(the_point[1])), 3, (0, 255, 0, 0), -1, 8, 0)
        		for the_point in tracking_data2['features']:
        			cv.Circle(frame, (int(the_point[0]), int(the_point[1])), 3, (255, 0, 0, 0), -1, 8, 0)
		cv.PutText(frame, "fps: " + str(fps[2]*dico_player["vitesse_vraie"])[:-6], (10, 20), font, 255)	# texte, fps tronquée
		cv.PutText(frame, "speed: " + str(dico_player["vitesse_vraie"]), (10, 35), font, 255)
		cv.PutText(frame, "Brut", (600, 20), font, 255)
		cv.PutText(frame, "Frame : " + str(n) , (450, 20), font, 255)
        	cv.ShowImage('AntsTracking', frame)
        elif retour[2] == 0 :					# Affichage de l'image après traitement
        	if tracking_data['night_mode']:
            	# night mode: only display the points
           		 cv.SetZero(grey2)
		if retour[1] :
			pass
        		#for the_point in tracking_data['features']:
        		#	cv.Circle(grey2, (int(the_point[0]), int(the_point[1])), 3, (0, 255, 0, 0), -1, 8, 0) 
		cv.PutText(grey2, "fps: " + str(fps[2]*dico_player["vitesse_vraie"])[:-6], (10, 20), font, 255)
		cv.PutText(grey2, "speed: " + str(dico_player["vitesse_vraie"]), (10, 35), font, 255)
		cv.PutText(grey2, "Grey", (600, 20), font, 255)
		cv.PutText(grey2, "Frame : " + str(n) , (450, 20), font, 255)
        	cv.ShowImage('AntsTracking', grey2)     
        else :							# Affichage de l'image après différence
       		if tracking_data['night_mode']:
            	# night mode: only display the points
           		 cv.SetZero(diff)
		if retour[1] :
			pass
        		#for the_point in tracking_data['features']:
        		#	cv.Circle(diff, (int(the_point[0]), int(the_point[1])), 3, (0, 255, 0, 0), -1, 8, 0)
		cv.PutText(diff, "fps: " + str(fps[2]*dico_player["vitesse_vraie"])[:-6], (10, 20), font, 255)
		cv.PutText(diff, "speed: " + str(dico_player["vitesse_vraie"]), (10, 35), font, 255)
		cv.PutText(diff, "diff", (600, 20), font, 255)
		cv.PutText(diff, "Frame : " + str(n) , (450, 20), font, 255)
        	cv.ShowImage('AntsTracking', diff)
        
		
def on_mouse (event, x, y, flags, data):	# the callback on the trackbar
    # we will use the global pt and add_remove_pt    
    #if data['image'] is None:
    #    # not initialized, so skip
    #    #return
    #if data['image'].origin != 0:
    #    # different origin
    #    #y = data['image'].height - y
    #y = 480 -y
    if event == cv.CV_EVENT_LBUTTONDOWN:
        # user has click, so memorize it
        data['pt'] = (x, y)
        data['add_remove_pt'] = True

class GestionTrackbar() :
	def seuil1(self, pos) :
		if pos%2 == 0 :
			pos = pos+1
		if pos < 3 :
			pos = 3
		self.var['seuil1'] = pos
	def seuil2(self, pos) :
		self.var['seuil2'] = pos
	def seuil3(self, pos) :
		self.var['seuil3'] = pos
	def erosion(self, pos) :
		self.var['erosion'] = pos   
		
        
