#! /usr/bin/env python
# _*-coding:utf-8-*-
# Modifié par PPPP, GPLv3+
# Script qui gère les modifications video depuis une source
# AntsTracking v0.1.7/v0.1.7

import cv, os

# ==================== Fonctions
# ==================== Gestion de la différence absolue
def difference(reference, frame) :
	"""Fonction qui réalise la différence absolue par rapport à une image de référence prédéfinie"""
	diff = cv.CreateImage(cv.GetSize(frame), cv.IPL_DEPTH_8U, 3)
	cv.AbsDiff(frame, reference , diff)		# Différence absolue
	return diff
# ==================== Gestion de l'image de référence
def laplacien(brut) :
	"""Application du Laplacien (détection de contours)"""
	planes = [cv.CreateImage((brut.width, brut.height), 8, 1) for i in range(3)]
        laplace = cv.CreateImage((brut.width, brut.height), cv.IPL_DEPTH_16S, 1)
        colorlaplace = cv.CreateImage((brut.width, brut.height), 8, 3)
	cv.Split(brut, planes[0], planes[1], planes[2], None)
	for plane in planes:
                cv.Laplace(plane, laplace, 3)
                cv.ConvertScaleAbs(laplace, plane, 1, 0)
	cv.Merge(planes[0], planes[1], planes[2], None, colorlaplace)
	return colorlaplace
	
def contraste(imgDiff, seuil, erosion) :
	"""Fonction qui applique des filtres de contraste, et un laplacien"""
	moy = cv.Avg(imgDiff)				# Calcul de la moyenne
	moy2 = []
	for i in range(len(moy)) :
		moy2.append(moy[i] + 35)				# Ajout de 35 à la moyenne
	cv.Smooth(imgDiff, imgDiff)		# Flou
	cv.SubS(imgDiff, moy, imgDiff)		# Soustraction de la moyenne plus 35
	imgDiff = laplacien(imgDiff)		# On applique le laplacien (détection de contours)
    	# ==== Flou et seuil
    	grey = cv.CreateImage(cv.GetSize(imgDiff), 8, 1)	
    	cv.CvtColor(imgDiff, grey, cv.CV_BGR2GRAY)			# Vers N&B
	cv.Smooth(grey, grey)						# Flou
	cv.Threshold(grey, grey, seuil, 255, cv.CV_THRESH_BINARY)	# Seuil (bon = 17, 255)
	cv.Erode(grey, grey, None, erosion)		# Erosion (bon = 0)
	return (grey, imgDiff)
	
def reference_init() :
	"""Fonction qui initialise un dictionnaire de référence pour la différence entre images"""
	liste = os.listdir("./reference_diff/")
	liste2 = []
	for i in liste :
		liste2.append(int(i[9:-4]))
	image = cv.LoadImage("./reference_diff/reference%s.JPG" % str(max(liste2)))
	dico = {"reference" : image, "path" : 0, "index" : 1}		# la variable change est inutile
	return dico
def new_reference(dico , dico_tracking, frame) :
	"""Fonction qui renvoie l'image de référence, si elle a été modifiée et la change si nécessaire"""
    	if dico_tracking['save'] :					# Si il faut enregistremer l'image de fond
		# Récupération du dernier index
		path = os.listdir('./reference_diff/')
		index = 1
		for i in path :
			index_c = int(i[9:-4])
			if index_c > index :
				index = index_c
		# Enregistrement
		cv.SaveImage('./reference_diff/reference%s.JPG'  % str(index+1) , frame)
		# Modification du dictionnaire
		dico = {"reference" : frame, "change" : 0, "index" : index+1 }    	
    		dico_tracking['save'] = 0				# Réinitialisation du compteur d'enregistrement
    		dico['reference'] = cv.LoadImage("./reference_diff/reference%s.JPG" % str(dico['index']))# Chargement de l'image de référence  
	return dico
	
def next_reference(dico, dico_tracking) :
    	if dico_tracking['next'] :
    		try :
    			dico['index'] += 1
    			dico['reference'] = cv.LoadImage("./reference_diff/reference%s.JPG" % str(dico['index']+1))# Chargement de l'image de référence      
    		except :
    			dico['index'] = 1
    			dico['reference'] = cv.LoadImage("./reference_diff/reference1.JPG")# Chargement de l'image de référence  
    		dico_tracking['next'] = 0 
    	return dico
    	
def double_diff() :
	"""Fonction muette et non fonctionnelle qui réalise l'elimination du bruit par somme de deux images avec différence successives"""
	if n>=2 :
		dico = [dico[1], dico_images['brut']]
		#	old		new	
		imgNew = mod_traitement.difference(dico_ref['reference'], dico[1])
		imgOld =mod_traitement.difference(dico_ref['reference'], dico[0])
		addition = cv.CreateImage(cv.GetSize(dico[1]), cv.IPL_DEPTH_8U, 3)
		cv.Add(imgNew, imgOld, addition)	# Calcul de la somme des deux différences
		dico_images['diff'] = addition
	else :
		dico = [0, dico_images['brut']]
